COMMENT
**************************************************************************************************
Procedure: Case3_Objective1
Purpose:   Compares the sort normalized addresses from Employee_Master and Vendor_Master where the
           zip codes are the same and creates a file of address matches
Results:   Table of vendors that have an address the same as an employee address
Created:   February 2020 by Arbutus Trainer
Modified:  June 2020 by Arbutus Trainer
Version:   1.2
**************************************************************************************************
END

COMMENT ** Set the environment

SET DEFAULT
SET SAFETY OFF
SET TEMP "Temp_"
CLOSE PRIMARY ALL

COMMENT ** Analysis

OPEN Vendor_Master
DEFINE FIELD c_Vendor_Key COMPUTED SortNormalize(Vendor_Address "USPS_Address.txt")

OPEN Employee_Master
DEFINE FIELD c_Employee_Key COMPUTED SortNormalize(street_Address "USPS_Address.txt") + Blanks(16)

OPEN Vendor_Master
OPEN Employee_Master SECONDARY
JOIN MANY PKEY c_Vendor_Key FIELDS ALL SKEY c_Employee_Key WITH ALL IF Zip_Code = Employee_Master.ZIP_CODE TO R_Vendor_Employee_Address_Many_Join PRESORT SECSORT

OPEN R_Vendor_Employee_Address_Many_Join
