COMMENT
**************************************************************************************************
Procedure: Case3_Objective2
Purpose:   Identifies instances where product prices were greater than 2% above the standard price
           during the month of December 2020
Results:   Table of products exceeding standard prices and total excess amounts
Created:   February 2020 by Arbutus Trainer
Modified:  June 2020 by Arbutus Trainer
Version:   1.2
**************************************************************************************************
END

COMMENT **Set environment

SET DEFAULT
SET SAFETY OFF
CLOSE PRIMARY ALL
SET TEMP "Temp_"

COMMENT **Analysis

OPEN Invoice_Line_Items
SUMMARIZE ON Vendor_Number Prod_No FIELDS Amount SUMMTYPE SUM AS 'SUM_Amount' Units SUMMTYPE SUM AS 'SUM_Units' Invoice_Date SUMMTYPE FIRST AS 'FIRST_Invoice_Date' PRESORT TO Temp_ILI_Summ_Vendor_Product

OPEN Temp_ILI_Summ_Vendor_Product
DEFINE FIELD c_Vendor_Unit_Cost COMPUTED SUM_Amount / SUM_Units
OPEN Product_Master SECONDARY
JOIN PKEY Prod_No FIELDS ALL SKEY Prod_No WITH ALL TO R_ILI_Summ_Join_Matched_Primary_Product_Master PRESORT SECSORT

OPEN R_ILI_Summ_Join_Matched_Primary_Product_Master
DEFINE FIELD c_Exceeds_Standard_Price COMPUTED
AS "Exceeds Standard;Price"
0.00 IF c_Vendor_Unit_Cost <= Unit_Cost
(c_Vendor_Unit_Cost - Unit_Cost) * SUM_Units

DEFINE FIELD c_Percent_Exceeds_Standard_Price COMPUTED (c_Exceeds_Standard_Price * 100.00) / SUM_Amount

COMMENT ** Create a file for December 2020 of products with percent exceeds standard price greater than 2
EXTRACT RECORD IF c_Percent_Exceeds_Standard_Price > 2 AND Between(FIRST_Invoice_Date `20241201` `20241231`) TO Temp_Exceptions

COMMENT ** Create Product Summary
OPEN Temp_Exceptions
SUMMARIZE ON Prod_No FIELDS c_Exceeds_Standard_Price SUMMTYPE SUM AS 'SUM_c_Exceeds_Standard_Price' IF c_Percent_Exceeds_Standard_Price > 2 PRESORT TO R_Products_Exceeding_Standard_Price

OPEN R_Products_Exceeding_Standard_Price
TOTAL FIELDS SUM_c_Exceeds_Standard_Price

COMMENT ** Extra credit solution

OPEN R_ILI_Summ_Join_Matched_Primary_Product_Master
SUMMARIZE ON Prod_No FIELDS c_Vendor_Unit_Cost SUMMTYPE MIN AS 'Min_Vendor_Unit_Cost' c_Vendor_Unit_Cost SUMMTYPE MAX AS 'Max_Vendor_Unit_Cost' c_Vendor_Unit_Cost SUMMTYPE AVG AS 'Avg_Vendor_Unit_Cost' PRESORT TO R_ILI_Summ_Product_With_Min_Max_Avg_Price

OPEN R_ILI_Summ_Product_With_Min_Max_Avg_Price


