*Created from history, file HRJoinPDMany: 01/26/2020 20:13:40
COMMENT
************************************************************************************
Procedure: Case4_IT_Testing
Purpose:   Identifies policy violations for new and terminated employees
Results:   Table of exceptions
Created:   February 2020 by Arbutus Trainer
Modified:  June 2020 by Arbutus Trainer
Version:   1.2
************************************************************************************
END

COMMENT ** Set Environment
SET DEFAULT
SET SAFETY OFF

COMMENT ** Analysis
OPEN HR_Data
DEFINE FIELD c_HR_Key COMPUTED Substr(Lower(Substr(First_Name 1 1) + Alltrim(Last_Name))1 15)
DUPLICATES ON c_HR_Key PRESORT TO R_HR_Duplicate_Keys

OPEN PD_Accounts_List
DEFINE FIELD c_PD_Accounts_Key COMPUTED Substr( Include( User_Name "a~z" )  1 15)
DUPLICATES ON c_PD_Accounts_key PRESORT TO R_PD_Duplicate_Keys

OPEN HR_Data
OPEN PD_Accounts_List SECONDARY
JOIN MANY PKEY c_HR_Key AS 'c_HR_Key' FIELDS ALL SKEY c_PD_Accounts_Key WITH ALL IF Between(PD_Accounts_List.Account_Deactivate_Request - Term_Date_Time `e00` `e5/00`) TO R_HR_Many_Join_PD_Accounts PRESORT SECSORT

OPEN R_HR_Many_Join_PD_Accounts
COMMENT ** New accounts should be created within 18 hours and 30 minutes of start datetime
DEFINE FIELD c_Gap_Hired_Account_Create COMPUTED Account_Created - Start_Date_Time
EXTRACT ALL TO R_HR_PD_New_Account_Exceptions IF c_Gap_Hired_Account_Create > `e18:30`

OPEN R_HR_Many_Join_PD_Accounts
COMMENT ** IM team should receive notification within 20 hours of employee termination
DEFINE FIELD c_Gap_Term_Deactivate COMPUTED Account_Deactivate_Request - Term_Date_Time
EXTRACT ALL TO R_HR_PD_Term_Request_Exceptions IF c_Gap_Term_Deactivate > `e20`

OPEN R_HR_Many_Join_PD_Accounts
COMMENT ** Employee should be deactivated within 8 hours of deactivation request
DEFINE FIELD c_Gap_Request_Deactivated COMPUTED Account_Deactivated - Account_Deactivate_Request
EXTRACT ALL TO R_HR_PD_Deactivate_Exceptions IF c_Gap_Request_Deactivated > `e06:45`
